/**
 * DB Controller.
 *
 * Controller encargado de crear la base de datos y de insertar los valores
 * iniciales
 *
 * @author JuanRamon Segura Ponce
 *
 * @version v.1.0
 * @throws Throws in DAO
 */
package controller;

import com.opensymphony.xwork2.ActionSupport;
import model.sql.IniBD;

public class BDController extends ActionSupport {

    private String user = null;
    private String pass = null;

    /**
     * Constructor Vacio
     */
    public BDController() {
    }

    /**
     * Getter del parametro User
     *
     * @return Retorna el usuario de la BD.
     */
    public String getUser() {
        return user;
    }

    /**
     * Setter del parametro User
     *
     * @param user Usuario de la BD.
     */
    public void setUser(String user) {
        this.user = user;
    }

    /**
     * Getter del parametro pass
     *
     * @return Retorna el pass de la BD.
     */
    public String getPass() {
        return pass;
    }

    /**
     * Setter del parametro pass
     *
     * @param pass Password de la BD.
     */
    public void setPass(String pass) {
        this.pass = pass;
    }

    /**
     * Funcion para crear la base de datos y las tablas
     *
     * @return Retorna "OK".
     */
    public String createBD() {
        IniBD iniBd = new IniBD();

        iniBd.parametros(user, pass);

        iniBd.createBD();

        return "OK";
    }

    /**
     * Funcion que inserta registros iniciales a la BD
     *
     * @return Retorna "OK".
     */
    public String iniBD() {
        IniBD iniBd = new IniBD();

        iniBd.parametros(user, pass);

        iniBd.iniBD();

        return "OK";
    }
}
