/**
  * Login Controller.
  * 
  * Responde a eventos referente a la CLASE LOGIN ,invoca peticiones al 'modelo' procedentes UNICAMENTE de la OPERACION LOGOUT.
  * 
  * ESTA ACCION ES LA QUE CIERRA LA SESION, parametrizada de Origen con 30 Minutos.
  * 
  * @author JuanRamon Segura Ponce
  *
  * @version v.1.0
  * @throws Throws in DAO
  */


package controller.login;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import java.util.Map;


public class LogoutAction extends ActionSupport {

    public static final String USER_SESSION_PARAM = "UsuarioLogueado";

    /**
     * Constructor Vacio.
     */
    public LogoutAction() {
    }

    /**
     * Execute del Action
     * 
     * @return Retorna "OK" o "KO" dependiendo del Exito del Procedimiento.
     */
    @Override
    public String execute() {
        removeUserData();
        return SUCCESS;
    }

    /**
     * Elimina de sesión los datos del usuario logueado.
     */
    private void removeUserData() {
        Map session = ActionContext.getContext().getSession();
        session.remove("usuario");
    }
}