package model.sql;

import java.sql.*;
import model.util.MessageUtil;

public class IniBD {

    private Connection conexion;
    static String user = null;
    static String password = null;
    static String server = null;

    public IniBD() {
    }

    public boolean parametros(String user, String password) {
        this.user = user;
        this.password = password;
        this.server = "jdbc:mysql://localhost/test";
        return true;
    }

    public boolean establecerConexion() {
        try {
            Class.forName("com.mysql.jdbc.Driver");
            conexion = DriverManager.getConnection(server, user, password);
            return true;
        } catch (Exception e) {
            System.out.println("Imposible realizar conexion con la BD");
            MessageUtil message = new MessageUtil(e.toString());
            return false;
        }
    }

    public Connection getConexion() {
        return conexion;
    }

    public void cerrar(ResultSet rs) {
        if (rs != null) {
            try {
                rs.close();
            } catch (Exception e) {
                MessageUtil message = new MessageUtil("No es posible cerrar la Conexion");
            }
        }
    }

    public void cerrar(java.sql.Statement stmt) {
        if (stmt != null) {
            try {
                stmt.close();
            } catch (Exception e) {
            }
        }
    }

    public void destruir() {

        if (conexion != null) {

            try {
                conexion.close();
            } catch (Exception e) {
            }
        }
    }
    
    public void createBD() {
        try {
            this.establecerConexion();
            Statement stm = null;

            if (conexion != null) {
                stm = conexion.createStatement();
            } else {
                MessageUtil message = new MessageUtil("No Hay conexion con la BD");
            }
        
            stm.executeUpdate("CREATE DATABASE TFC");
            stm.executeUpdate("USE TFC");
            
            stm.executeUpdate("CREATE TABLE DOCUMENTO(idDocumento integer unique NOT NULL AUTO_INCREMENT,numeroDocumento character varying(9) UNIQUE NOT NULL,tipoDocumento character varying(3) NOT NULL,CONSTRAINT pk_Documento_idDocumento PRIMARY KEY (idDocumento))");
            stm.executeUpdate("CREATE TABLE PERSONA(idPersona integer NOT NULL AUTO_INCREMENT,idDocumento integer UNIQUE NOT NULL,nombre character varying(16) NOT NULL,apellido1 character varying(16) NOT NULL,apellido2 character varying(16) NOT NULL,idioma character varying(16) NOT NULL,telefono character varying(10) UNIQUE NOT NULL,email character varying(32) UNIQUE NOT NULL,CONSTRAINT pk_Persona PRIMARY KEY (idPersona),CONSTRAINT fk_Persona_Documento FOREIGN KEY (idDocumento) REFERENCES DOCUMENTO (idDocumento))");
            stm.executeUpdate("CREATE TABLE DEPARTAMENTO (idDepartamento integer NOT NULL AUTO_INCREMENT,departamento character varying(32) NOT NULL,codigoDepartamento character varying(4) UNIQUE NOT NULL,CONSTRAINT pk_Departamento_idDepartamento PRIMARY KEY (idDepartamento))");
            stm.executeUpdate("CREATE TABLE LOGIN (idLogin integer unique NOT NULL AUTO_INCREMENT,usuario character varying(16) unique NOT NULL,password character(16) NOT NULL,dataPassWord date NOT NULL,CONSTRAINT pk_Login PRIMARY KEY (idLogin))");
            stm.executeUpdate("CREATE TABLE USUARIO (idUsuario integer unique NOT NULL,idLogin integer NOT NULL,tipoUsuario character(1) NOT NULL,idDepartamento integer NOT NULL,estadoEnSistema character(1) NOT NULL,emailUsuario character varying(64) UNIQUE NOT NULL,telefonoUsuario character varying(10) UNIQUE NOT NULL,CONSTRAINT pk_Usuario PRIMARY KEY (idUsuario),CONSTRAINT fk_Usuario_Persona FOREIGN KEY (idUsuario) REFERENCES PERSONA (idPersona),CONSTRAINT fk_Usuario_Departamento FOREIGN KEY (idDepartamento) REFERENCES DEPARTAMENTO (idDepartamento),CONSTRAINT fk_Usuario_Login FOREIGN KEY (idLogin) REFERENCES LOGIN (idLogin))");
            stm.executeUpdate("CREATE TABLE INCIDENCIA (idIncidencia integer NOT NULL AUTO_INCREMENT,origen character varying(3) NOT NULL,destino character varying(3) NOT NULL,asunto character varying(64) NOT NULL,incidencia character varying(320) NOT NULL,estado character varying(1) NOT NULL,dataApertura date NOT NULL,respuesta character varying(320),dataCierre date,CONSTRAINT ck_DataCartel CHECK (dataApertura <= dataCierre),CONSTRAINT pk_Incidencia PRIMARY KEY (idIncidencia))");
            stm.executeUpdate("CREATE TABLE ARTICULO (idArticulo integer NOT NULL AUTO_INCREMENT,descripcion1 character varying(64) NOT NULL,descripcion2 character varying(64) NOT NULL,descripcion3 character varying(64),precio float NOT NULL,precioOferta float,tecla integer,unidad character varying(1) NOT NULL,codInterno character varying(6) UNIQUE,ean character varying(13) UNIQUE NOT NULL,CONSTRAINT pk_Articulo PRIMARY KEY (idArticulo))");
            stm.executeUpdate("CREATE TABLE PLANTILLA (idPlantilla integer NOT NULL AUTO_INCREMENT,tipo character varying(16) NOT NULL,tamano character varying(16) NOT NULL,CONSTRAINT pk_Plantilla PRIMARY KEY (idPlantilla))");
            stm.executeUpdate("CREATE TABLE CARTEL (idCartel integer NOT NULL AUTO_INCREMENT,idPlantilla integer NOT NULL,idArticulo integer NOT NULL,dataIni date,dataFi date,CONSTRAINT ck_DataCartel CHECK (dataIni <= dataFi),CONSTRAINT pk_Cartel PRIMARY KEY (idCartel),CONSTRAINT fk_Cartel_idPlantilla FOREIGN KEY (idPlantilla) REFERENCES PLANTILLA (idPlantilla),CONSTRAINT fk_Cartel_idArticulo FOREIGN KEY (idArticulo) REFERENCES ARTICULO (idArticulo))");
            stm.executeUpdate("CREATE TABLE TRABAJO (idTrabajo integer NOT NULL AUTO_INCREMENT,descripcion character varying(64) UNIQUE NOT NULL,prioridad integer NOT NULL,fechaCreacion date NOT NULL,CONSTRAINT pk_Trabajo PRIMARY KEY (idTrabajo))");
            stm.executeUpdate("CREATE TABLE CARTELES (idTrabajo integer NOT NULL,idCartel integer NOT NULL,CONSTRAINT pk_Carteles PRIMARY KEY (idTrabajo,idCartel),CONSTRAINT fk_Carteles_idTrabajo FOREIGN KEY (idTrabajo) REFERENCES TRABAJO (idTrabajo),CONSTRAINT fk_Carteles_idCartel FOREIGN KEY (idCartel) REFERENCES CARTEL (idCartel))");
            stm.executeUpdate("CREATE TABLE ESTADOTRABAJO (idEstadoTrabajo integer NOT NULL AUTO_INCREMENT,idTrabajo integer NOT NULL,idUsuario integer NOT NULL,estado character varying(1) NOT NULL,fechaEstado date NOT NULL,CONSTRAINT pk_traImprimidos PRIMARY KEY (idEstadoTrabajo),CONSTRAINT fk_traImprimidos_idTrabajo FOREIGN KEY (idTrabajo) REFERENCES TRABAJO (idTrabajo),CONSTRAINT fk_traImprimidos_idUsuario FOREIGN KEY (idUsuario) REFERENCES USUARIO (idUsuario))");
            
            stm.executeUpdate("COMMIT");

            MessageUtil message = new MessageUtil("Base de Datos creada con Exito");
        } catch (SQLException SQLe) {
            MessageUtil message = new MessageUtil("Ha Ocurrido un Error al crear la Base de Datos");
        }
    }

    public void iniBD() {
        try {
            this.establecerConexion();
            Statement stm = null;

            if (conexion != null) {
                stm = conexion.createStatement();
            } else {
                MessageUtil message = new MessageUtil("No Hay conexion con la BD");
            }
        
            stm.executeUpdate("USE TFC");
             
            stm.executeUpdate("Insert into DOCUMENTO (numeroDocumento,tipoDocumento) values ('111111111','NIF')");
            stm.executeUpdate("Insert into DOCUMENTO (numeroDocumento,tipoDocumento) values ('222222222','NIE')");
            stm.executeUpdate("Insert into DOCUMENTO (numeroDocumento,tipoDocumento) values ('333333333','CIF')");

            stm.executeUpdate("Insert into DEPARTAMENTO(departamento,codigoDepartamento) values ('TIENDA','00B0')");
            stm.executeUpdate("Insert into DEPARTAMENTO(departamento,codigoDepartamento) values ('SEDE','S001')");
            stm.executeUpdate("Insert into DEPARTAMENTO(departamento,codigoDepartamento) values ('REGIONAL','R001')");

            stm.executeUpdate("Insert into persona(idDocumento,nombre,apellido1,apellido2,idioma,telefono,email) values('1','Nombre1','Apellido11','Apellido21','Español','Telefono1','email1')");
            stm.executeUpdate("Insert into persona(idDocumento,nombre,apellido1,apellido2,idioma,telefono,email) values('2','Nombre2','Apellido12','Apellido22','Ingles','Telefono2','email2')");
            stm.executeUpdate("Insert into persona(idDocumento,nombre,apellido1,apellido2,idioma,telefono,email) values('3','Nombre3','Apellido13','Apellido23','Frances','Telefono3','email3')");

            stm.executeUpdate("Insert into LOGIN (usuario,password,dataPassWord)values('userA','pass',CURDATE())");
            stm.executeUpdate("Insert into LOGIN (usuario,password,dataPassWord)values('userR','pass',CURDATE())");
            stm.executeUpdate("Insert into LOGIN (usuario,password,dataPassWord)values('userU','pass',CURDATE())");

            //tipoUsuario--->A Administrador, R ResponsableCarteleria i U UsuarioFinal
            //estadoEnSistema---->A Activo i B Bloqueado
            stm.executeUpdate("Insert into USUARIO (idUsuario,idLogin,tipoUsuario,idDepartamento,estadoEnSistema,emailUsuario,telefonoUsuario)values('1','1','A','1','A','email1','telefono1')");
            stm.executeUpdate("Insert into USUARIO (idUsuario,idLogin,tipoUsuario,idDepartamento,estadoEnSistema,emailUsuario,telefonoUsuario)values('2','2','R','2','A','email2','telefono2')");
            stm.executeUpdate("Insert into USUARIO (idUsuario,idLogin,tipoUsuario,idDepartamento,estadoEnSistema,emailUsuario,telefonoUsuario)values('3','3','U','3','A','email3','telefono3')");
            
            stm.executeUpdate("Insert into PLANTILLA (tipo,tamano) values('Frescos','A4')");
            stm.executeUpdate("Insert into PLANTILLA (tipo,tamano) values('Frescos','Display')");
            stm.executeUpdate("Insert into PLANTILLA (tipo,tamano)values('PGC','A4')");
            stm.executeUpdate("Insert into PLANTILLA (tipo,tamano)values('PGC','Display')");
            
            stm.executeUpdate("COMMIT");

            MessageUtil message = new MessageUtil("Se ha insertado los Registros con Exito");
        } catch (Exception e) {
            MessageUtil message = new MessageUtil("No se ha podido insertar datos en la BD");
        }
    }
}
    /*
    public void leerSQL(String fichero) throws IOException, SQLException {
        String s = new String();
        StringBuffer sb = new StringBuffer();

        MessageUtil messag = new MessageUtil(System.getProperty("user.dir"));

        FileReader fr = new FileReader(new File(fichero));
        Statement stm = null;

        if (conexion != null) {
            stm = conexion.createStatement();
        } else {
            MessageUtil message = new MessageUtil("No Hay conexion con la BD");
        }

        BufferedReader br = new BufferedReader(fr);
        while ((s = br.readLine()) != null) {
            sb.append(s);
        }
        br.close();
        // here is our splitter ! We use ";" as a delimiter for each request
        // then we are sure to have well formed statements
        String[] inst = sb.toString().split(";");
        for (int i = 0; i < inst.length; i++) {
            // we ensure that there is no spaces before or after the request 
            // string in order to not execute empty statements
            if (!inst[i].trim().equals("")) {
                stm.executeUpdate(inst[i] + ";");
            }
        }
    }*/